/*
	header file for PROforma
	definition of a system subroutines

	(c) PROGS, Professional & Graphical Software
	written by Joachim Van der Auwera
	started 20 July 1993
*/

#include <mem.h>
#include <str.h>
#include <io.h>

/* routines to allocate and release some system memory (PROforma.c) */
Error PFAllocate(Size size, void **base);
Error PFRelease(void *base);

/* routines to create some QDOS output */
long prints(long chid, char *s);
#define prints(c,s) IOPutString(c,s,NULL)

/* routine to adjust the CharWidth according to the given character pair */
int glyphwidth(font *f, char *base);
int KernAdjust(Gstate, short leftchar, short rightchar);
void KernAdjustWidth(Gstate, short leftchar, short rightchar);
int CharWidth(Gstate, int code);
int PCharWidth(Gstate, int code);

/* special aid routine, converts user coordinates to device coordinates */
/* C routine, code in PFparams as this file handles the parameters */
void user2dev(Gstate, coor *c);
void reluser2dev(Gstate, coor *c);
Error PFChar2UniCode(Gstate, char *n, char **ret);

Error fillpath(Gstate,
			  Error (*Trapezoid)(Bitmap, short starty, short endy,
					pt leftstartx, pt leftincr, pt rightstartx, pt rightincr),
			  Bitmap bitmap, int rule);
Error cfillpath(Gstate gstate,
				Error (*Line)(Bitmap, short, short, short),
				Bitmap bitmap);

#define StringContinues(gstate,x) ( (x) && (x)!=(gstate)->extraeos )
Error CalcChar(Gstate, short code);
Error PFShowChar(Gstate gstate, int code);

Error CacheGstateInit(Gstate gstate);
Error CacheFontRelease(CachedFont **ifc);
Error CacheInit();
Error CacheAllocate(Size length, int count);
Error CacheFontFind(Gstate gstate);
Error CacheFind(CachedFont *font, short unicode, CachedMask **ret);
Error CacheCreate(CachedFont *font, short unicode, short xsiz, short ysiz,
				  CachedMask **ret);
Error FontReleaseCaches(font *f);
Error FontResidentLoad(char *filename);
Error CacheFontCalculate(CachedFont *font);

Error currCTMset(Gstate gstate);
Error ReleaseClipPath(Gstate gstate);
